package com.steerinfo.baseinfo.meterbaserailwayaiweight.controller;

import com.steerinfo.baseinfo.meterbaserailwayaiweight.mapper.MeterBaseRailwayAiweightMapper;
import com.steerinfo.baseinfo.meterbaserailwayaiweight.model.MeterBaseRailwayAiweight;
import com.steerinfo.baseinfo.meterbaserailwayaiweight.service.IMeterBaseRailwayAiweightService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseRailwayAiweight RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-05-18 09:54
 * 类描述
 * 修订历史：
 * 日期：2022-05-18
 * 作者：generator
 * 参考：
 * 描述：MeterBaseRailwayAiweight RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaserailwayaiweights")
public class MeterBaseRailwayAiweightController extends BaseRESTfulController {

    @Autowired
    IMeterBaseRailwayAiweightService meterBaseRailwayAiweightService;

    @Resource
    MeterBaseRailwayAiweightMapper meterBaseRailwayAiweightMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayaiweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayAiweight> list = meterBaseRailwayAiweightService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayaiweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayAiweight> list = meterBaseRailwayAiweightService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayaiweight:view")
    @PostMapping(value = "/noPage")
    public RESTfulResult noPage(@RequestBody HashMap parmas){
        List<MeterBaseRailwayAiweight> list = meterBaseRailwayAiweightService.noPage(parmas);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseRailwayAiweight对象创建")
    @ApiImplicitParam(name = "meterBaseRailwayAiweight", value = "详细实体meterBaseRailwayAiweight", required = true, dataType = "MeterBaseRailwayAiweight")
    //@RequiresPermissions("meterbaserailwayaiweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseRailwayAiweight model){
        MeterBaseRailwayAiweight meterBaseRailwayAiweight = meterBaseRailwayAiweightService.add(model);
        return success(meterBaseRailwayAiweight);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayaiweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseRailwayAiweight meterBaseRailwayAiweight = meterBaseRailwayAiweightService.getById(id);
        return success(meterBaseRailwayAiweight);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseRailwayAiweight信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseRailwayAiweight", value = "详细实体meterBaseRailwayAiweight", required = true, dataType = "MeterBaseRailwayAiweight")
    })
    //@RequiresPermissions("meterbaserailwayaiweight:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseRailwayAiweight model){
        model.setId(id);
        MeterBaseRailwayAiweight meterBaseRailwayAiweight = meterBaseRailwayAiweightService.modify(model);
        return success(meterBaseRailwayAiweight);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayaiweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseRailwayAiweightService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="批量新增", notes="根据List<MeterBaseRailwayAiweight>对象批量创建")
    @PostMapping(value = "/checkAdd")
    public RESTfulResult checkAdd(@RequestBody List<MeterBaseRailwayAiweight> models){
        RESTfulResult rm = meterBaseRailwayAiweightService.checkAdd(models);
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkRailwayReceived", value = "详细实体meterWorkRailwayReceived", required = true, dataType = "MeterWorkRailwayReceived")
    })
//@RequiresPermissions("meterworkrailwayreceived:update")
    @PostMapping(value = "/updateAI", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateAI(@RequestBody MeterBaseRailwayAiweight model){
        RESTfulResult rm = new RESTfulResult();
        try {
            int num = meterBaseRailwayAiweightMapper.updateByPrimaryKeySelective(model);
            rm.setCode("200");
            rm.setData(num);
            rm.setMessage("成功");
            return rm;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @GetMapping(value = "/likeByDesc/")
    public RESTfulResult likeByDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayAiweight> list = meterBaseRailwayAiweightService.likeByDesc(parmas, pageNum, pageSize);
        return success(list);
    }
}
